unit U_TradeClothTotalOutList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Vcl.Printers, Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData,
  cxDataStorage, cxEdit, DB, cxDBData, cxGridCustomTableView, cxGridTableView,
  cxGridBandedTableView, cxGridDBBandedTableView, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridDBTableView, cxGrid, StdCtrls, ComCtrls,
  ExtCtrls, ToolWin, cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient,
  cxDropDownEdit, cxCheckBox, RM_Common, RM_Class, RM_e_Xls, RM_Dataset,
  RM_System, RM_GridReport, Menus, cxCalendar, cxButtonEdit, cxTextEdit, cxPC,
  cxLookAndFeels, cxLookAndFeelPainters, cxNavigator, dxDateRanges,
  dxBarBuiltInMenu, U_BaseList, Clipbrd, dxScrollbarAnnotations, FrameDateSel,
  cxContainer, cxMaskEdit, cxProgressBar, cxButtons, dxSkinsCore,
  dxSkinsDefaultPainters, System.Math;

type
  TfrmTradeClothTotalOutList = class(TfrmBaseList)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBExport: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    ADOQueryCmd: TADOQuery;
    ADO_1: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DS_1: TDataSource;
    GPM_1: TcxGridPopupMenu;
    CDS_1: TClientDataSet;
    TBDel: TToolButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    TBAdd: TToolButton;
    TBEdit: TToolButton;
    Label3: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label12: TLabel;
    C_NAME: TcxTextEdit;
    BCIONO: TcxTextEdit;
    C_spec: TcxTextEdit;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    N3: TMenuItem;
    ToolButton3: TToolButton;
    Label4: TLabel;
    Label9: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    FromCoName: TcxTextEdit;
    ToCoName: TcxTextEdit;
    ToOrdNo: TcxTextEdit;
    FromOrdNo: TcxTextEdit;
    frmFrameDateSel1: TfrmFrameDateSel;
    IOType: TcxComboBox;
    ADOQueryPrint: TADOQuery;
    ToolButton4: TToolButton;
    cxPageControl1: TcxPageControl;
    cxTabSheet1: TcxTabSheet;
    cxGrid2: TcxGrid;
    TV2: TcxGridDBTableView;
    cxGridDBColumn14: TcxGridDBColumn;
    cxGridDBColumn9: TcxGridDBColumn;
    cxGridDBColumn15: TcxGridDBColumn;
    cxGridDBColumn16: TcxGridDBColumn;
    cxGridDBColumn24: TcxGridDBColumn;
    cxGridDBColumn26: TcxGridDBColumn;
    cxGridDBColumn28: TcxGridDBColumn;
    cxGridDBColumn29: TcxGridDBColumn;
    cxGridDBColumn17: TcxGridDBColumn;
    cxGridLevel1: TcxGridLevel;
    cxTabSheet2: TcxTabSheet;
    cxGrid1: TcxGrid;
    Tv1: TcxGridDBTableView;
    Tv1Column5: TcxGridDBColumn;
    v1Column5: TcxGridDBColumn;
    v1Column6: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v1Column4: TcxGridDBColumn;
    v1Column15: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    v1Column13: TcxGridDBColumn;
    v1Column16: TcxGridDBColumn;
    v1Column17: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v1Column20: TcxGridDBColumn;
    v1Column8: TcxGridDBColumn;
    v1Column10: TcxGridDBColumn;
    Tv1Column6: TcxGridDBColumn;
    Tv1Column7: TcxGridDBColumn;
    v1Column18: TcxGridDBColumn;
    Tv1Column1: TcxGridDBColumn;
    Tv1Column28: TcxGridDBColumn;
    Tv1Column29: TcxGridDBColumn;
    Tv1Column18: TcxGridDBColumn;
    Tv1Column19: TcxGridDBColumn;
    v1Column19: TcxGridDBColumn;
    Tv1Column35: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    Tv1Column8: TcxGridDBColumn;
    Tv1Column2: TcxGridDBColumn;
    Tv1Column4: TcxGridDBColumn;
    Tv1Column3: TcxGridDBColumn;
    Tv1Column9: TcxGridDBColumn;
    Tv1Column30: TcxGridDBColumn;
    Tv1Column31: TcxGridDBColumn;
    Tv1Column10: TcxGridDBColumn;
    Tv1Column11: TcxGridDBColumn;
    Tv1Column21: TcxGridDBColumn;
    Tv1Column22: TcxGridDBColumn;
    Tv1Column13: TcxGridDBColumn;
    Tv1Column12: TcxGridDBColumn;
    v1Column12: TcxGridDBColumn;
    Tv1Column14: TcxGridDBColumn;
    Tv1Column15: TcxGridDBColumn;
    Tv1Column20: TcxGridDBColumn;
    Tv1Column16: TcxGridDBColumn;
    Tv1Column17: TcxGridDBColumn;
    Tv1Column23: TcxGridDBColumn;
    Tv1Column32: TcxGridDBColumn;
    Tv1Column24: TcxGridDBColumn;
    Tv1Column25: TcxGridDBColumn;
    Tv1Column26: TcxGridDBColumn;
    Tv1Column27: TcxGridDBColumn;
    Tv1Column33: TcxGridDBColumn;
    Tv1Column34: TcxGridDBColumn;
    cxGrid1Level1: TcxGridLevel;
    TV2Column1: TcxGridDBColumn;
    TV2Column2: TcxGridDBColumn;
    GPM_2: TcxGridPopupMenu;
    CDS_2: TClientDataSet;
    DS_2: TDataSource;
    ADO_2: TADOQuery;
    TV2Column3: TcxGridDBColumn;
    Tv1Column36: TcxGridDBColumn;
    ToolButton5: TToolButton;
    cxTabControl1: TcxTabControl;
    Panel6: TPanel;
    Label31: TLabel;
    LBCPAP: TLabel;
    BTLP: TButton;
    BTNP: TButton;
    TCBNOR: TcxComboBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure SPNameChange(Sender: TObject);
    procedure BCIOIDChange(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure TBEditClick(Sender: TObject);
    procedure C_specChange(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure BCIOIDPropertiesChange(Sender: TObject);
    procedure cxButtonbqxzClick(Sender: TObject);
    procedure cxButton4Click(Sender: TObject);
    procedure cxButton5Click(Sender: TObject);
    procedure cxButton3Click(Sender: TObject);
    procedure cxButton1Click(Sender: TObject);
    procedure cxButton2Click(Sender: TObject);
    procedure BCIONOKeyPress(Sender: TObject; var Key: Char);
    procedure IOTypePropertiesChange(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure cxPageControl1Change(Sender: TObject);
    procedure TV2DblClick(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
  private
    CurrentPage, RecordsNumber: Integer;
    canshu1, FSTKName, canshu3, canshu4: string;
    procedure InitGrid1();
    procedure InitGrid2();
    procedure InitGrid(MWSql: string);
    { Private declarations }
  public
    { Public declarations }
  end;

//var
 // frmPBOutList: TfrmPBOutList;

implementation

uses
  U_DataLink, U_RTFun, U_TradeTotallClothOutinput, U_AttachmentUpload,
  U_ProgressUpdate, U_LabelPrint, U_PrintLabFun, U_dynamicsDll, U_printPdf,
  U_InputReceiptType;

{$R *.dfm}
procedure TfrmTradeClothTotalOutList.InitGrid(MWSql: string);
var
  WSql, WDateSql: string;
  SqlStr: string;
begin

  WDateSql := ' and A.Filltime>' + quotedstr(FormatDateTime('yyyy-MM-dd', frmFrameDateSel1.BegDate.Date));
  WDateSql := WDateSql + ' and A.Filltime<=' + quotedstr(FormatDateTime('yyyy-MM-dd', frmFrameDateSel1.enddate.Date + 1));
  WDateSql := WDateSql + ' and isnull(STKNAME,'''')=''' + Trim(FSTKNAME) + '''';
  if Trim(canshu4) <> '' then
    WDateSql := WDateSql + ' and isnull(StkCoName,'''')=''' + Trim(canshu4) + '''';
  case cxTabControl1.TabIndex of
    0:
      begin
        WDateSql := WDateSql + ' and Status=''0'' ';
      end;
    1:
      begin
        WDateSql := WDateSql + ' and Status=''1'' ';
      end;
  end;

  case cxPageControl1.ActivePageIndex of
    0:
      begin
//        WSql := CommonFiltersByContainer(dxLayoutControl_query, '  {"EquTag": 1,"LikeTag": 2,"Fields": "OrderNo|FtyPCId|FtyPCId|C_Color|C_Code|C_Name"}');
        if trim(WSql) <> '' then
        begin
          WSql := WDateSql + ' and ' + trim(WSql);
        end
        else
          WSql := WDateSql;

        SqlStr := ' select A.ReceiptType,A.BCIONO,A.ToCoName,A.C_Code,C_Name,C_Color,C_ColorNo,C_Degree,C_Pattern,QtyUnit ';
        SqlStr := SqlStr + '  ,Pieceint=sum(CEILING(A.Piece)),Qty=sum(Qty),QtyUnit ';
        SqlStr := SqlStr + ' from BS_Cloth_IO A    ';
        SqlStr := SqlStr + ' where 1=1 ' + (WSql);
        SqlStr := SqlStr + ' and ioFlag=''出库''  ';
        SqlStr := SqlStr + ' group by A.ReceiptType,A.BCIONO,A.ToCoName,C_Code,C_Name,C_Color,C_ColorNo,C_Degree,C_Pattern,QtyUnit';
//  ShowMessage(SqlStr);
        InitCDSData(ADO_2, CDS_2, Tv2, SqlStr, SGetFilters(Panel1, 1, 2), 'C_Code');
      end;
    1:
      begin
        if MWSql = '' then
          WSql := CommonFiltersByContainer(panel1, ' {"EquTag": 1,"LikeTag": 2,"Fields": ""}')
        else
          WSql := MWSql;

        if trim(WSql) <> '' then
        begin
          WSql := WDateSql + ' and ' + trim(WSql);
        end
        else
          WSql := WDateSql;

        SqlStr := 'exec P_Trade_Totaloutlist_Get_Page ';
        SqlStr := SqlStr + ' @pageIndex=' + inttostr(CurrentPage);
        SqlStr := SqlStr + ' ,@pageSize=' + inttostr(RecordsNumber);
        SqlStr := SqlStr + ' ,@criteria= ' + quotedstr(WSql);
//        showmessage(SqlStr);
        InitCDSData(ADO_1, CDS_1, Tv1, SqlStr, SGetFilters(Panel1, 1, 2), 'C_Code');
        LBCPAP.Caption := inttostr(CurrentPage) + '/' + inttostr(ceil(CDS_1.FieldByName('TotalCount').AsInteger / RecordsNumber));
      end;
  end;

end;

procedure TfrmTradeClothTotalOutList.InitGrid1();
var
  SqlStr, WSqlStr: string;
begin

  SqlStr := ' select A.* ,Pieceint=CEILING(A.Piece)';
  SqlStr := SqlStr + ',FJFlag=CAST((CASE WHEN (SELECT COUNT(X.FileName) FROM FJ_File X where X.TFType=''贸易汇总布'' and X.WBID=A.BCIOID)>0 THEN 1 ELSE 0 END) AS BIT)                ';
  SqlStr := SqlStr + ' from BS_Cloth_IO A';
  SqlStr := SqlStr + ' where A.IOTime>=''' + Trim(FormatDateTime('yyyy-MM-dd', frmFrameDateSel1.BegDate.Date)) + '''';
  SqlStr := SqlStr + ' and A.IOTime<''' + Trim(FormatDateTime('yyyy-MM-dd', frmFrameDateSel1.enddate.Date + 1)) + '''';
  SqlStr := SqlStr + ' and isnull(stkName,'''')=''' + Trim(FstkName) + '''';
  SqlStr := SqlStr + ' and ioFlag=''出库''  ';
  case cxTabControl1.TabIndex of
    0:
      begin
        SqlStr := SqlStr + ' and Status=''0'' ';
      end;
    1:
      begin
        SqlStr := SqlStr + ' and Status=''1'' ';
      end;
  end;
  WSqlStr := CommonFiltersByTv(Tv2, '{"RemovalNull":true,"Fields":"BCIONO"}');
  if TRIM(WSqlStr) <> '' then
    SqlStr := SqlStr + ' and ' + WSqlStr;
  if Trim(canshu4) <> '' then
    SqlStr := SqlStr + ' and isnull(StkCoName,'''')=''' + Trim(canshu4) + '''';

  InitCDSData(ADO_1, CDS_1, Tv1, SqlStr, SGetFilters(Panel1, 1, 2), 'BCIOID');
end;

procedure TfrmTradeClothTotalOutList.InitGrid2();
var
  SqlStr: string;
begin

  SqlStr := ' select A.ReceiptType,A.BCIONO,A.ToCoName,A.C_Code,C_Name,C_Color,C_ColorNo,C_Degree,C_Pattern,QtyUnit ';

  SqlStr := SqlStr + '  ,Pieceint=sum(CEILING(A.Piece)),Qty=sum(Qty),QtyUnit ';
  SqlStr := SqlStr + ' from BS_Cloth_IO A    ';
  SqlStr := SqlStr + ' where A.IOTime>=''' + Trim(FormatDateTime('yyyy-MM-dd', frmFrameDateSel1.BegDate.Date)) + '''';
  SqlStr := SqlStr + ' and A.IOTime<''' + Trim(FormatDateTime('yyyy-MM-dd', frmFrameDateSel1.enddate.Date + 1)) + '''';
  SqlStr := SqlStr + ' and isnull(stkName,'''')=''' + Trim(FstkName) + '''';
  SqlStr := SqlStr + ' and ioFlag=''出库''  ';
  case cxTabControl1.TabIndex of
    0:
      begin
        SqlStr := SqlStr + ' and Status=''0'' ';
      end;
    1:
      begin
        SqlStr := SqlStr + ' and Status=''1'' ';
      end;
  end;
  if Trim(canshu4) <> '' then
    SqlStr := SqlStr + ' and isnull(StkCoName,'''')=''' + Trim(canshu4) + '''';
  SqlStr := SqlStr + ' group by A.ReceiptType,A.BCIONO,A.ToCoName,C_Code,C_Name,C_Color,C_ColorNo,C_Degree,C_Pattern,QtyUnit';

//  ShowMessage(SqlStr);
  InitCDSData(ADO_2, CDS_2, Tv2, SqlStr, SGetFilters(Panel1, 1, 2), 'C_Code');

end;

procedure TfrmTradeClothTotalOutList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TfrmTradeClothTotalOutList.FormCreate(Sender: TObject);
begin
  inherited;
  canshu1 := Trim(self.fParameters1);
  FSTKName := Trim(self.fParameters2);
  canshu3 := Trim(self.fParameters3);
  canshu4 := Trim(self.fParameters4);
  frmFrameDateSel1.EndDate.Date := SGetServerDate(ADOQueryTemp);
  frmFrameDateSel1.BegDate.Date := frmFrameDateSel1.EndDate.Date - 90;
end;

procedure TfrmTradeClothTotalOutList.IOTypePropertiesChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmTradeClothTotalOutList.TBRafreshClick(Sender: TObject);
begin
  ToolBar1.SetFocus;
//  InitGrid2();
  CurrentPage := 1;
  InitGrid('');
end;

procedure TfrmTradeClothTotalOutList.ToolButton1Click(Sender: TObject);
begin
  WriteCxGrid(trim(Self.Caption) + 'Tv1', Tv1, '贸易汇总仓库');
  WriteCxGrid(trim(Self.Caption) + 'Tv2', Tv2, '贸易汇总仓库');
end;

procedure TfrmTradeClothTotalOutList.ToolButton2Click(Sender: TObject);
var
  MBCIOID: string;
begin

  case cxPageControl1.ActivePageIndex of
    0:
      begin
        MBCIOID := Trim(CDS_2.fieldbyname('BCIONo').AsString)
      end;
    1:
      begin
        MBCIOID := Trim(CDS_1.fieldbyname('BCIONo').AsString)
      end;
  end;

  try
    frmLabelPrint := TfrmLabelPrint.Create(Application);
    with frmLabelPrint do
    begin
      FLMType := 'TradeFinishClothOutPrt1';
      FFiltration1 := MBCIOID;
      if ShowModal = 1 then
      begin

//        with ADOQueryCmd do
//        begin
//          Close;
//          sql.Clear;
//          sql.Add('update BS_Cloth_IO         ');
//          sql.Add(' set PRTer=' + quotedstr(DName));
//          sql.Add(', PRTCount=isnull(PRTCount,0)+1');
//          sql.Add(', PRTDate=getdate()');
//          sql.Add(' where EXISTS (select SP.RTValue from [dbo].[F_Tool_SplitString](' + quotedstr(MBCIOID) + ','','') SP where SP.RTValue=BS_Cloth_IO.BCIOID )');
//          ExecSQL;
//        end;
//        Self.InitGrid2();
      end;
    end;
  finally
    frmLabelPrint.Free;
  end;
end;

procedure TfrmTradeClothTotalOutList.ToolButton3Click(Sender: TObject);
begin
  if CDS_1.IsEmpty then
    Exit;
  try
    frmAttachmentUpload := TfrmAttachmentUpload.Create(Application);
    with frmAttachmentUpload do
    begin
      fkeyNO := Trim(Self.CDS_1.fieldbyname('BCIOID').AsString);
      fType := '贸易汇总布';
      FEditAuthority := True;
      if ShowModal = 1 then
      begin

      end;
    end;
  finally
    frmAttachmentUpload.Free;
  end;
end;

procedure TfrmTradeClothTotalOutList.ToolButton4Click(Sender: TObject);
begin
  if cxPageControl1.ActivePageIndex <> 1 then
    Exit;
  if CDS_1.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
  try
    frmLabelPrint := TfrmLabelPrint.Create(Application);
    with frmLabelPrint do
    begin
      FLMType := 'TradeLabVolume1';
      FFiltration1 := Trim(SelCDSKey(self.CDS_1, ['BCIOID'])[0]);
      if ShowModal = 1 then
      begin

      end;
    end;
  finally
    frmLabelPrint.Free;
  end;
end;

procedure TfrmTradeClothTotalOutList.ToolButton5Click(Sender: TObject);
var
  MBCIONo: string;
begin

  case cxPageControl1.ActivePageIndex of
    0:
      begin
        MBCIONo := Trim(CDS_2.fieldbyname('BCIONo').AsString)
      end;
    1:
      begin
        MBCIONo := Trim(CDS_1.fieldbyname('BCIONo').AsString)
      end;
  end;

  try
    frmInputReceiptType := TfrmInputReceiptType.Create(Application);
    with frmInputReceiptType do
    begin

      if ShowModal = 1 then
      begin
//        with ADOQueryCmd do
//        begin
//          Close;
//          sql.Clear;
//          sql.Add('update BS_Cloth_IO         ');
//          sql.Add(' set ReceiptType=' + quotedstr(frmInputReceiptType.cxComboBox1.Text));
//          sql.Add(' where  BCIONo=' + QuotedStr(Trim(MBCIONo)));
//          ExecSQL;
//        end;
        Self.InitGrid2();
      end;
    end;
  finally
    frmInputReceiptType.Free;
  end;
end;

procedure TfrmTradeClothTotalOutList.TV2DblClick(Sender: TObject);
begin
  cxPageControl1.ActivePageIndex := 1;
end;

procedure TfrmTradeClothTotalOutList.BCIOIDPropertiesChange(Sender: TObject);
begin
  if Length(Trim(TcxTextEdit(Sender).Text)) < 4 then
    Exit;
  TBFind.Click;
end;

procedure TfrmTradeClothTotalOutList.BCIONOKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
    InitGrid2();
end;

procedure TfrmTradeClothTotalOutList.TBCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TfrmTradeClothTotalOutList.FormShow(Sender: TObject);
var
  mSql: string;
begin
  inherited;
  CurrentPage := 1;
  RecordsNumber := 500;
  mSql := 'select distinct name=A.IOType from BS_Cloth_IO A where IOFlag=''出库'' and isnull(STKNAME,'''')=''' + Trim(FSTKNAME) + ''' ';
  SInitTcxComBoxBySql(ADOQueryTemp, IOType, false, mSql);

  ReadCxGrid(trim(Self.Caption) + 'Tv1', Tv1, '贸易汇总仓库');
  ReadCxGrid(trim(Self.Caption) + 'Tv2', Tv2, '贸易汇总仓库');
  InitGrid('');
//  InitGrid2();
end;

procedure TfrmTradeClothTotalOutList.TBExportClick(Sender: TObject);
begin
  if CDS_1.IsEmpty then
    exit;
  TcxGridToExcel(FstkName + '出库列表', cxGrid1);
end;

procedure TfrmTradeClothTotalOutList.TBFindClick(Sender: TObject);
begin
  case cxPageControl1.ActivePageIndex of
    0:
      begin
        CDSDataFilter(ADO_2, CDS_2, Tv2, '{"FilterStr":"' + CommonFiltersByContainer(Panel1, '  {"EquTag": 1,"LikeTag": 2,"Fields": "C_name|C_Color|C_ColorNo"}') + '"  }');
      end;
    1:
      begin
        CDSDataFilter(ADO_1, CDS_1, Tv1, '{"FilterStr":"' + CommonFiltersByContainer(Panel1, '  {"EquTag": 1,"LikeTag": 2,"Fields": ""}') + '"  }');
      end;
  end;
end;

procedure TfrmTradeClothTotalOutList.SPNameChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmTradeClothTotalOutList.BCIOIDChange(Sender: TObject);
begin
  if Length(Trim(BCIOno.Text)) < 4 then
  begin
    if Trim(BCIOno.Text) <> '' then
      Exit;
  end;
  TBFind.Click;
end;

procedure TfrmTradeClothTotalOutList.N1Click(Sender: TObject);
begin
  SelOKNo(CDS_1, True);
end;

procedure TfrmTradeClothTotalOutList.N2Click(Sender: TObject);
begin
  SelOKNo(CDS_1, False);
end;

procedure TfrmTradeClothTotalOutList.N3Click(Sender: TObject);
begin
  Clipboard.SetTextBuf(PChar(Trim(CDS_1.fieldbyname(TV1.Controller.FocusedColumn.DataBinding.FilterFieldName).AsString)));
end;

procedure TfrmTradeClothTotalOutList.TBDelClick(Sender: TObject);
var
  MBCIOID, MBCIONO, MTMSId: string;
begin
  if cxPageControl1.ActivePageIndex <> 1 then
    Exit;
  if CDS_1.IsEmpty then
    Exit;

  if CDS_1.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;

  if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
    Exit;
  MBCIOID := SelCDSKey(CDS_1, ['BCIOID'])[0];
  MBCIONO := SelCDSKey(CDS_1, ['BCIONO'])[0];
  MTMSId := SelCDSKey(CDS_1, ['TMSId'])[0];
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('exec P_Fin_Flow_Judge ');
    Sql.Add(' @FFIDS=' + quotedstr(MBCIONO));
    Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
    Sql.Add(',@DName=' + quotedstr(Trim(DName)));
    Open;
  end;
  if ADOQueryTemp.FieldByName('intReturn').AsInteger = -1 then
  begin
    Application.MessageBox(PChar(ADOQueryTemp.fieldbyname('ShowMsg').AsString), '提示', 0);
    exit;
  end;
  try
    ADOQueryCmd.Connection.BeginTrans;

    with ADOQueryCmd do
    begin
      Close;
      Sql.Clear;
      Sql.Add('exec P_Trade_BSCloth_Judge ');
      Sql.Add(' @BCIOIDS=' + quotedstr(MBCIOID));
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));
      Open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));

    with ADOQueryCmd do
    begin
      Close;
      Sql.Clear;
      sql.Add('insert into Finance_Need_Up(UType,UDataId,UOperation,UOperator,UModule,UDetails) ');
      sql.Add('values(''贸易布坯出库''    ');
      sql.Add(',' + quotedstr(MBCIONO));
      sql.Add(',''删除''   ');
      sql.Add(',' + quotedstr(DName));
      sql.Add(',' + quotedstr(trim(self.Caption)));
      sql.Add(',' + quotedstr(MBCIOID));
      sql.Add(')  ');

      Sql.Add('exec P_BS_Cloth_Out_Del ');
      Sql.Add(' @BCIOIDS=' + quotedstr(MBCIOID));
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));
      Open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));
    ADOQueryCmd.Connection.CommitTrans;
    TradeMarketProgressUpdate(ADOQueryBaseCmd, MTMSId);
    InitGrid2();
    InitGrid1();
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    InitGrid2();
    InitGrid1();
  end;

end;

procedure TfrmTradeClothTotalOutList.TBAddClick(Sender: TObject);
begin
  try
    frmTradeTotallClothOutinput := TfrmTradeTotallClothOutinput.Create(Application);
    with frmTradeTotallClothOutinput do
    begin
      FBCId := '';
      FstkName := Self.FstkName;
      if ShowModal = 1 then
      begin
        Self.InitGrid2();
      end;
    end;
  finally
    frmTradeTotallClothOutinput.Free;
  end;
end;

procedure TfrmTradeClothTotalOutList.TBEditClick(Sender: TObject);
begin
  if cxPageControl1.ActivePageIndex <> 1 then
    Exit;
  if CDS_1.IsEmpty then
    Exit;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('exec P_Fin_Flow_Judge ');
    Sql.Add(' @FFIDS=' + quotedstr(Trim(CDS_1.fieldbyname('BCIOID').AsString)));
    Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
    Sql.Add(',@DName=' + quotedstr(Trim(DName)));
    Open;
  end;
  if ADOQueryTemp.FieldByName('intReturn').AsInteger = -1 then
  begin
    Application.MessageBox(PChar(ADOQueryTemp.fieldbyname('ShowMsg').AsString), '提示', 0);
    exit;
  end;
  with ADOQueryTemp do
  begin
    Close;
    Sql.Clear;
    Sql.Add('exec P_Trade_BSCloth_Judge ');
    Sql.Add(' @BCIOIDS=' + quotedstr(Trim(CDS_1.fieldbyname('BCIOID').AsString)));
    Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
    Sql.Add(',@DName=' + quotedstr(Trim(DName)));
    Open;
  end;
  if ADOQueryTemp.FieldByName('intReturn').AsInteger = -1 then
  begin
    Application.MessageBox(PChar(ADOQueryTemp.fieldbyname('ShowMsg').AsString), '提示', 0);
    exit;
  end;
  with ADOQueryTemp do
  begin
    Close;
    Sql.Clear;
    Sql.Add('exec P_BS_Cloth_Out_Edit ');
    Sql.Add(' @BCIOIDS=' + quotedstr(Trim(CDS_1.fieldbyname('BCIOID').AsString)));
    Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
    Sql.Add(',@DName=' + quotedstr(Trim(DName)));
//    ShowMessage(sql.Text);
    Open;
  end;
  if ADOQueryTemp.FieldByName('intReturn').AsInteger = -1 then
  begin
    Application.MessageBox(PChar(ADOQueryTemp.fieldbyname('ShowMsg').AsString), '提示', 0);
    exit;
  end;
  try
    frmTradeTotallClothOutinput := TfrmTradeTotallClothOutinput.Create(Application);
    with frmTradeTotallClothOutinput do
    begin
      FBCId := Trim(CDS_1.fieldbyname('BCIOID').AsString);

      FstkName := Self.FstkName;
      if ShowModal = 1 then
      begin
        Self.InitGrid1();
      end;
    end;
  finally
    frmTradeTotallClothOutinput.Free;
  end;

end;

procedure TfrmTradeClothTotalOutList.C_specChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmTradeClothTotalOutList.cxButtonbqxzClick(Sender: TObject);
var
  mrecid: Integer;
  MaxBLCLID: string;
begin
//  mrecid := showFr3LableForm(DCode, DName, DConString, '标签选择');
//  with ADOQueryTemp do
//  begin
//    close;
//    sql.Clear;
//    sql.Add('select top 1 * from Trade_Label');
//    sql.Add('where recid=' + trim(IntToStr(mrecid)));
//    Open;
//  end;
//  LabVolume.Text := Trim(ADOQueryTemp.fieldbyname('LabelCaption').AsString);
end;

procedure TfrmTradeClothTotalOutList.cxPageControl1Change(Sender: TObject);
begin
  case cxPageControl1.ActivePageIndex of
    1:
      begin
        InitGrid1();
      end;
  end;
end;

procedure TfrmTradeClothTotalOutList.cxButton1Click(Sender: TObject);
begin
  inherited;
  frmFrameDateSel1.cxButton1Click(Sender);
  InitGrid2();
end;

procedure TfrmTradeClothTotalOutList.cxButton2Click(Sender: TObject);
begin
  inherited;
  frmFrameDateSel1.cxButton2Click(Sender);
  InitGrid2();
end;

procedure TfrmTradeClothTotalOutList.cxButton3Click(Sender: TObject);
begin
  inherited;
  frmFrameDateSel1.cxButton4Click(Sender);
  InitGrid2();
end;

procedure TfrmTradeClothTotalOutList.cxButton4Click(Sender: TObject);
begin
  inherited;
  frmFrameDateSel1.cxButton4Click(Sender);
  InitGrid2();
end;

procedure TfrmTradeClothTotalOutList.cxButton5Click(Sender: TObject);
begin
  inherited;
  frmFrameDateSel1.cxButton5Click(Sender);
  InitGrid2();
end;

procedure TfrmTradeClothTotalOutList.cxTabControl1Change(Sender: TObject);
begin
  InitGrid2();
  initgrid1();
end;

end.

